;===============================================================================
;
; alternative flare star 1.0
;
; - change the damage algorithm of the flare star special effect
;
;===============================================================================
header
hirom

;===============================================================================
;
; pointers
;
;===============================================================================

org     $C24335 :   dw flare_star_null
org     $C23E21 :   dw flare_star_main

;===============================================================================
;
; flare star - main
;
;===============================================================================
org     $C2410F
flare_star_main:

    ;setup flags
        STZ $11A1               ;null elements
        LDA #$40                ;ignore defense, no split damage
        TSB $11A2               ;setup flag
        
    ;setup random number: [0, 15]
        JSR $4B5A               ;random number: [0, 255]
        TAX                     ;X = random number

    ;setup max hp
        REP #$20                ;mode 2AB
        LDA $3C1C,Y             ;target max hp
        CMP #$270F              ;9.999 hp
        BCC .skip_cap
        LDA #$270F              ;9.999 hp
.skip_cap        
        STA $11B0               ;save max hp
        SEP #$20                ;mode 1AB

    ;setup damage
        JSL flare_star_damage   ;to setup random damage

    ;exit
flare_star_null:
        RTS

warnpc  $C24135

;===============================================================================
;
; flare star - damage
;
; $11B0 in      = target's max hp
; 1X in         = random number [0, 255]
;
;===============================================================================
org     $C3FB00
flare_star_damage:

    ;setup radnom number in [0, 15] range
        TXA                     ;get random number
        AND #$0F                ;A = [0, 15]
        TAX                     ;save at X

    ;setup fraction of 1/16 of target hp
        REP #$20                ;2AB mode
        LDA $11B0               ;max hp
        LSR
        LSR
        LSR
        LSR
        INC
        PHA                     ;save 1/16 fraction

    ;setup damage based on fraction
        TDC                     ;clean AB
.loop
        SEC                     ;set carry
        ADC $01,S               ;add 1/16 fraction
        DEX                     ;subtract number of fractions
        BPL .loop

    ;save damage
        STA $11B0               ;save damage
        PLA                     ;free stack

    ;exit
        SEP #$20                ;1AB mode
        RTL 

warnpc  $C3FB1D

